diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index db51b879d..58838765d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -7,78 +7,82 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.piston.BlockLogicPistonBase;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModelStandard<T> {
-    private final IconCoordinate faceTexture;
-    protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/piston/side");
-    protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/piston/top");
-    protected IconCoordinate bottomTexture = TextureRegistry.getTexture("minecraft:block/piston/bottom");
+    private final @NotNull IconCoordinate faceTexture;
+    protected @NotNull IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/piston/side");
+    protected @NotNull IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/piston/top");
+    protected @NotNull IconCoordinate bottomTexture = TextureRegistry.getTexture("minecraft:block/piston/bottom");
 
     protected final double headThickness;
-    public BlockModelPiston(Block<T> block, IconCoordinate faceTexture){
-        this(block, faceTexture, 4/16d);
+
+    public BlockModelPiston(Block<T> block, @NotNull IconCoordinate faceTexture) {
+        this(block, faceTexture, 4 / 16d);
     }
 
-    public BlockModelPiston(Block<T> block, IconCoordinate faceTexture, double headThickness){
+    public BlockModelPiston(Block<T> block, @NotNull IconCoordinate faceTexture, double headThickness) {
         super(block);
         this.headThickness = headThickness;
         this.faceTexture = faceTexture;
     }
 
-    public BlockModelPiston<T> setPistonTextures(IconCoordinate sideTexture, IconCoordinate topTexture, IconCoordinate bottomTexture) {
+    public BlockModelPiston<T> setPistonTextures(@NotNull IconCoordinate sideTexture, @NotNull IconCoordinate topTexture, @NotNull IconCoordinate bottomTexture) {
         this.sideTexture = sideTexture;
         this.topTexture = topTexture;
         this.bottomTexture = bottomTexture;
         return this;
     }
 
-    public BlockModelPiston<T> setPistonTextures(String sideTexture, String topTexture, String bottomTexture) {
+    public BlockModelPiston<T> setPistonTextures(@NotNull String sideTexture, @NotNull String topTexture, @NotNull String bottomTexture) {
         return setPistonTextures(TextureRegistry.getTexture(sideTexture), TextureRegistry.getTexture(topTexture), TextureRegistry.getTexture(bottomTexture));
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z){
-        return renderPistonBase(tessellator, worldSource, x, y, z, false);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        return renderPistonBase(tessellator, worldSource, tilePos, false);
     }
 
     private boolean headless = false;
-    public boolean renderHeadless(Tessellator tessellator, WorldSource worldSource, int x, int y, int z) {
+
+    public boolean renderHeadless(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePos tilePos) {
         renderBlocks.renderAllFaces = true;
-        headless = true;
-        boolean result = renderPistonBase(tessellator, worldSource, x, y, z, true);
-        headless = false;
+        this.headless = true;
+        boolean result = renderPistonBase(tessellator, worldSource, tilePos, true);
+        this.headless = false;
         renderBlocks.renderAllFaces = false;
         return result;
     }
-    protected boolean renderPistonBase(Tessellator tessellator, WorldSource worldSource, int x, int y, int z, boolean noCulling) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
+
+    protected boolean renderPistonBase(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean noCulling) {
+        int meta = worldSource.getBlockData(tilePos);
         boolean extended = noCulling || (meta & 8) != 0;
         Direction direction = BlockLogicPistonBase.getDirection(meta);
-        AABB bounds;
-        if(extended)
-        {
-            switch(direction)
-            {
+        AABBdc bounds;
+        if (extended) {
+            switch (direction) {
                 case DOWN: // '\0'
                     renderBlocks.uvRotateEast = 3;
                     renderBlocks.uvRotateWest = 3;
                     renderBlocks.uvRotateSouth = 3;
                     renderBlocks.uvRotateNorth = 3;
-                    bounds = AABB.fromPool(0.0F, headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
+                    bounds = new AABBd(0.0F, this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case UP: // '\001'
-                    bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1 - headThickness, 1.0F);
+                    bounds = new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1 - this.headThickness, 1.0F);
                     break;
 
                 case NORTH: // '\002'
                     renderBlocks.uvRotateSouth = 1;
                     renderBlocks.uvRotateNorth = 2;
-                    bounds = AABB.fromPool(0.0F, 0.0F, headThickness, 1.0F, 1.0F, 1.0F);
+                    bounds = new AABBd(0.0F, 0.0F, this.headThickness, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case SOUTH: // '\003'
@@ -86,7 +90,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateNorth = 1;
                     renderBlocks.uvRotateTop = 3;
                     renderBlocks.uvRotateBottom = 3;
-                    bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - headThickness);
+                    bounds = new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - this.headThickness);
                     break;
 
                 case WEST: // '\004'
@@ -94,7 +98,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateWest = 2;
                     renderBlocks.uvRotateTop = 2;
                     renderBlocks.uvRotateBottom = 1;
-                    bounds = AABB.fromPool(headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    bounds = new AABBd(this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case EAST: // '\005'
@@ -102,18 +106,16 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateWest = 1;
                     renderBlocks.uvRotateTop = 1;
                     renderBlocks.uvRotateBottom = 2;
-                    bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F);
+                    bounds = new AABBd(0.0F, 0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F);
                     break;
 
                 default:
-                    bounds = AABB.fromPool(0, 0, 0, 1, 1, 1);
+                    bounds = new AABBd(0, 0, 0, 1, 1, 1);
             }
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
             renderBlocks.resetRenderBlocks();
-        } else
-        {
-            switch(direction)
-            {
+        } else {
+            switch (direction) {
                 case DOWN: // '\0'
                     renderBlocks.uvRotateEast = 3;
                     renderBlocks.uvRotateWest = 3;
@@ -147,39 +149,34 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateBottom = 2;
                     break;
             }
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBounds(), x, y, z);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBounds(), tilePos);
             renderBlocks.resetRenderBlocks();
         }
         return true;
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         super.renderStandalone(tessellator, 1, brightness, alpha, lightmapCoordinate);
     }
-    public IconCoordinate getFaceTexture()
-    {
-        return faceTexture;
+
+    public @NotNull IconCoordinate getFaceTexture() {
+        return this.faceTexture;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         Direction direction = BlockLogicPistonBase.getDirection(data);
-        if (direction == Direction.NONE)
-        {
-            return blockTextures.get(Side.BOTTOM);
+        if (direction == Direction.NONE) {
+            return this.blockTextures.get(Side.BOTTOM);
         }
-        if (side.getDirection() == direction)
-        {
-            if (BlockLogicPistonBase.isPowered(data) || headless)
-            {
-                return topTexture;
-            }
-            else
-            {
-                return blockTextures.get(Side.BOTTOM);
+        if (side.getDirection() == direction) {
+            if (BlockLogicPistonBase.isPowered(data) || this.headless) {
+                return this.topTexture;
+            } else {
+                return this.blockTextures.get(Side.BOTTOM);
             }
         }
-        return side.getDirection() != direction.getOpposite() ? sideTexture : bottomTexture;
+        return side.getDirection() != direction.getOpposite() ? this.sideTexture : this.bottomTexture;
     }
 }
